#define  F_CPU    2000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "hd44780.h"

int main(void) {
	
	// przycisk
	PORTE.DIRCLR	=	PIN5_bm;					// pin E5 jako wejcie (przycisk FLIP)
	PORTE.PIN5CTRL	=	PORT_OPC_PULLUP_gc;			// podcignicie do zasilania
	
	// diody od PWM
	PORTE.DIRSET	=	0b00001111;					// piny 3..0 jako wyjcie
	
	// wywietlacz
	LcdInit();
	
	// konfiguracja timera
	TCE0.CTRLB		=	TC_WGMODE_DSBOTH_gc|		// tryb normalny
						TC0_CCAEN_bm|
						TC0_CCBEN_bm|
						TC0_CCCEN_bm|
						TC0_CCDEN_bm;
	TCE0.PER		=	10000;
	TCE0.CCA		=	2000;
	TCE0.CCB		=	4000;
	TCE0.CCC		=	6000;
	TCE0.CCD		=	8000;
	TCE0.CTRLA		=	TC_CLKSEL_DIV1024_gc;		// ustawienie preskalera i uruchomienie timera
	
	while(1) {
		// wywietlenie aktualnej wartoci licznika CNT i PER
		// CNT = ...
		// PER = ...
		LcdClear();
		Lcd("CNT = ");
		LcdDec(TCE0.CNT);
		Lcd2;
		Lcd("PER = ");
		LcdDec(TCE0.PER);
		_delay_ms(100);	
		
		if(!(PORTE.IN & PIN5_bm)) {						// przycisk FLIP przyspiesza PWM
			TCE0.PER		=	1000;
			TCE0.CCA		=	10;
			TCE0.CCB		=	50;
			TCE0.CCC		=	200;
			TCE0.CCD		=	500;
			TCE0.CTRLA		=	TC_CLKSEL_DIV1_gc;		
		}
		
	}
}